"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const load_json_file_1 = require("load-json-file");
const path = require("path");
async function readImporterManifest(filename) {
    return load_json_file_1.default(filename);
}
exports.readImporterManifest = readImporterManifest;
async function readImporterManifestFromDir(dir) {
    return readImporterManifest(path.join(dir, 'package.json'));
}
exports.readImporterManifestFromDir = readImporterManifestFromDir;
async function safeReadImporterManifest(filename) {
    try {
        return await readImporterManifest(filename);
    }
    catch (err) {
        if (err['code'] !== 'ENOENT')
            throw err;
        return null;
    }
}
exports.safeReadImporterManifest = safeReadImporterManifest;
function safeReadImporterManifestFromDir(dir) {
    return safeReadImporterManifest(path.join(dir, 'package.json'));
}
exports.safeReadImporterManifestFromDir = safeReadImporterManifestFromDir;
//# sourceMappingURL=readImporterManifest.js.map